Merge remote-tracking branch 'origin/pr/239'
[grml-debootstrap.git] / chroot-script
1 #!/bin/bash
2 # Filename:      /etc/debootstrap/chroot-script
3 # Purpose:       script executed in chroot when installing Debian via grml-debootstrap
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8 # GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
9 # this script as /bin/chroot-script on your new installed system
10 ################################################################################
11 # shellcheck disable=SC2317  # shellcheck has trouble understanding the code flow in this file
12
13 # error_handler {{{
14 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
15    set -e
16    set -E
17    set -o pipefail
18    trap "error_handler" ERR
19 fi
20 # }}}
21
22 # shellcheck source=config
23 . /etc/debootstrap/config    || exit 1
24 # shellcheck source=tests/shellcheck-stub-debootstrap-variables
25 . /etc/debootstrap/variables || exit 1
26
27 [ -r /proc/1 ] || mount -t proc none /proc
28 [ -r /sys/kernel ] || mount -t sysfs none /sys
29
30 # variable checks {{{
31
32 # use aptitude only if it's available
33 if [ -x /usr/bin/aptitude ] ; then
34    APTUPDATE="aptitude update $DPKG_OPTIONS"
35    # Debian ISOs do not contain signed Release files
36    if [ -n "$ISO" ] ; then
37       APTINSTALL="aptitude -y --allow-untrusted --without-recommends install $DPKG_OPTIONS"
38       APTUPGRADE="aptitude -y --allow-untrusted safe-upgrade $DPKG_OPTIONS"
39    else
40       APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
41       APTUPGRADE="aptitude -y safe-upgrade $DPKG_OPTIONS"
42    fi
43 else
44    APTINSTALL="apt-get -y --no-install-recommends install $DPKG_OPTIONS"
45    APTUPDATE="apt-get update $DPKG_OPTIONS"
46    APTUPGRADE="apt-get -y upgrade $DPKG_OPTIONS"
47 fi
48
49 if [ -z "$STAGES" ] ; then
50    STAGES='/etc/debootstrap/stages'
51    [ -d "$STAGES" ] || mkdir -p "$STAGES"
52 fi
53 # }}}
54
55 # helper functions {{{
56 stage() {
57   if [ -n "$2" ] ; then
58      echo "$2" > "$STAGES/$1"
59      return 0
60   elif grep -q 'done' "$STAGES/$1" 2>/dev/null ; then
61      echo "   [*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
62      return 1
63   fi
64   echo "   Executing stage ${1}"
65   return 0
66 }
67
68 askpass() {
69   # read -s emulation for dash. result is in $resp.
70   set -o noglob
71   [ -t 0 ] && stty -echo
72   read -r resp
73   [ -t 0 ] && stty echo
74   set +o noglob
75 }
76 # }}}
77
78 # define chroot mirror {{{
79 chrootmirror() {
80   if [ "$KEEP_SRC_LIST" = "yes" ] ; then
81     echo "KEEP_SRC_LIST has been enabled, skipping chrootmirror stage."
82     return
83   fi
84
85   if [ -z "$COMPONENTS" ] ; then
86     COMPONENTS='main'
87   fi
88   echo "Using repository components $COMPONENTS"
89
90   if [ -n "$ISO" ] ; then
91     echo "Adjusting sources.list for ISO (${ISO})."
92     echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
93
94     if [ -n "$MIRROR" ] ; then
95       echo "Adding mirror entry (${MIRROR}) to sources.list."
96       echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
97     fi
98   else
99     if [ -n "$MIRROR" ] ; then
100       echo "Adjusting sources.list for mirror (${MIRROR})."
101       echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
102     fi
103   fi
104
105   # add security.debian.org:
106   case "$RELEASE" in
107     unstable|sid) ;;  # no security pool available
108     jessie|stretch|buster)
109       echo "Adding security.debian.org to sources.list."
110       echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
111       ;;
112     *)
113       # bullseye and newer releases use a different repository layout, see
114       # https://lists.debian.org/debian-devel-announce/2019/07/msg00004.html
115       echo "Adding security.debian.org/debian-security to sources.list."
116       echo "deb http://security.debian.org/debian-security ${RELEASE}-security $COMPONENTS" >> /etc/apt/sources.list
117       ;;
118   esac
119 }
120 # }}}
121
122 # remove local chroot mirror {{{
123 remove_chrootmirror() {
124   if [ "$KEEP_SRC_LIST" = "yes" ] ; then
125     echo "KEEP_SRC_LIST has been enabled, skipping remove_chrootmirror stage."
126     return
127   fi
128
129   if [ -n "$ISO" ] ; then
130     echo "Removing ISO (${ISO}) from sources.list."
131     TMP_ISO="${ISO//\//\\\/}"
132     sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
133   else
134     if [ -n "$MIRROR" ] && echo "$MIRROR" | grep -q 'file:' ; then
135       echo "Removing local mirror (${MIRROR}) from sources.list."
136       TMP_MIRROR="${MIRROR//\//\\\/}"
137       sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
138       echo "Adding fallback mirror entry (${FALLBACK_MIRROR}) to sources.list instead."
139       echo "deb $FALLBACK_MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
140     fi
141   fi
142 }
143 # }}}
144
145 # set up grml repository {{{
146 grmlrepos() {
147   if [ -z "$GRMLREPOS" ] ; then
148     return 0
149   fi
150
151   # user might have provided their own apt sources configuration
152   if [ -r /etc/apt/sources.list.d/grml.list ] ; then
153     echo "File /etc/apt/sources.list.d/grml.list exists already, not modifying."
154   else
155     echo "Setting up /etc/apt/sources.list.d/grml.list."
156     cat > /etc/apt/sources.list.d/grml.list << EOF
157 # grml: stable repository:
158   deb     [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-stable main
159   deb-src [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-stable main
160
161 # grml: testing/development repository:
162   deb     [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-testing main
163   deb-src [signed-by=/usr/share/keyrings/grml-archive-keyring.gpg] http://deb.grml.org/ grml-testing main
164 EOF
165   fi
166
167   # make sure we install packages from Grml's pool only if not available from Debian
168   if [ -r /etc/apt/preferences.d/grml.pref ] ; then
169     echo "File /etc/apt/preferences.d/grml.pref exists already, not modifying."
170   else
171     echo "Setting up /etc/apt/preferences.d/grml.pref."
172     cat > /etc/apt/preferences.d/grml.pref << EOF
173 Explanation: use Grml repository only after Debian ones
174 Package: *
175 Pin: origin deb.grml.org
176 Pin-Priority: 100
177 EOF
178   fi
179
180   apt-get update -o Acquire::AllowInsecureRepositories=1
181   apt-get -y --allow-unauthenticated install grml-debian-keyring
182   apt-get update
183
184   if [ "$(dpkg-query -f "\${db:Status-Status} \${db:Status-Eflag}" -W grml-debian-keyring 2>/dev/null)" != 'installed ok' ]; then
185     echo "Error: installation of grml-debian-keyring failed." >&2
186     exit 1
187   fi
188 }
189 # }}}
190
191 # feature to provide Debian backports repos {{{
192 backportrepos() {
193   if [ -n "$BACKPORTREPOS" ] ; then
194     cat >> /etc/apt/sources.list.d/backports.list << EOF
195 # debian backports: ${RELEASE}-backports repository:
196 deb     ${MIRROR} ${RELEASE}-backports main
197 deb-src ${MIRROR} ${RELEASE}-backports main
198 EOF
199   fi
200 }
201 # }}}
202
203 # set up kernel-img.conf {{{
204 kernelimg_conf() {
205   if ! [ -r /etc/kernel-img.conf ] ; then
206      echo "Setting up /etc/kernel-img.conf"
207      cat > /etc/kernel-img.conf << EOF
208 # Kernel Image management overrides
209 # See kernel-img.conf(5) for details
210 do_initrd = Yes
211 do_symlinks = Yes
212 EOF
213   fi
214 }
215 # }}}
216
217 # make sure services do not start up {{{
218 install_policy_rcd() {
219   if ! [ -r /usr/sbin/policy-rc.d ] ; then
220      export POLICYRCD=1
221      cat > /usr/sbin/policy-rc.d << EOF
222 #!/bin/sh
223 exit 101
224 EOF
225      chmod 775 /usr/sbin/policy-rc.d
226   fi
227 }
228 # }}}
229
230 # make sure we have an up2date system {{{
231 upgrade_system() {
232   if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
233     echo "Running update + upgrade"
234     $APTUPDATE
235     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTUPGRADE
236   else
237     echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
238   fi
239 }
240
241 # }}}
242 # remove now useless apt cache {{{
243 remove_apt_cache() {
244   if [ "$RM_APTCACHE" = 'yes' ] ; then
245     echo "Cleaning apt cache."
246     # shellcheck disable=SC2086
247     apt-get clean $DPKG_OPTIONS
248   else
249     echo "Not cleaning apt cache as \$RM_APTCACHE is unset."
250   fi
251 }
252 # }}}
253
254 # install additional packages {{{
255 packages() {
256   # Pre-seed the debconf database with answers. Each question will be marked
257   # as seen to prevent debconf from asking the question interactively.
258   [ -f /etc/debootstrap/debconf-selections ] && {
259     echo "Preseeding the debconf database, some lines might be skipped..."
260     debconf-set-selections < /etc/debootstrap/debconf-selections
261   }
262
263   if [ "$PACKAGES" = 'yes' ] ; then
264     PACKAGES_FILE="/etc/debootstrap/packages"
265
266     if [ "$ARCH" = 'arm64' ]; then
267       PACKAGES_FILE="/etc/debootstrap/packages-arm64"
268     fi
269
270     if ! [ -r "${PACKAGES_FILE}" ] ; then
271       echo "Error: ${PACKAGES_FILE} (inside chroot) not found, exiting." >&2
272       exit 1
273     else
274       $APTUPDATE
275
276       # shellcheck disable=SC2086,SC2046
277       DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $(grep -v '^#' "${PACKAGES_FILE}") $GRMLPACKAGES
278     fi
279   fi
280 }
281 # }}}
282
283 # install extra packages {{{
284 extrapackages() {
285     if [ "$EXTRAPACKAGES" = 'yes' ] ; then
286         PACKAGELIST=$(find /etc/debootstrap/extrapackages -type f -name '*.deb')
287         if [ -n "$PACKAGELIST" ]; then
288             # shellcheck disable=SC2086
289             dpkg -i $PACKAGELIST
290             # run apt again to resolve any deps
291             DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL
292         fi
293     fi
294 }
295 # }}}
296
297 # check if the specified Debian package exists
298 package_exists() {
299   output=$(apt-cache show "$1" 2>/dev/null)
300   [ -n "$output" ]
301   return $?
302 }
303
304
305 # determine the kernel version postfix
306 get_kernel_version() {
307   # do not override $KERNEL if set via config file
308   if [ -n "$KERNEL" ] ; then
309     echo "$KERNEL"
310     return 0
311   fi
312
313   local KARCH
314
315   # shellcheck disable=SC2153
316   case "$ARCH" in
317     i386)
318       KARCH='686-pae'
319       ;;
320     amd64)
321       KARCH='amd64'
322       ;;
323     arm64)
324       KARCH='arm64'
325       ;;
326     *)
327       echo "Only i386, amd64 and arm64 are currently supported" >&2
328       return 1
329   esac
330
331   local KPACKAGE
332   KPACKAGE=linux-image-"${KPREFIX}${KARCH}"
333   if package_exists "$KPACKAGE"; then
334     echo "${KPREFIX}${KARCH}"
335     return 0
336   fi
337
338   echo "Expected kernel package $KPACKAGE not found" >&2
339   return 1
340 }
341
342 # install kernel packages {{{
343 kernel() {
344   if [ -n "$NOKERNEL" ] ; then
345     echo "Skipping installation of kernel packages as requested via --nokernel"
346     return 0
347   fi
348
349   $APTUPDATE
350   KVER=$(get_kernel_version)
351   if [ -n "$KVER" ] ; then
352      # note: install busybox to be able to debug initramfs
353      KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free"
354      # only add firmware-linux if we have non-free as a component
355      if expr "$COMPONENTS" : '.*non-free' >/dev/null ; then
356        KERNELPACKAGES="$KERNELPACKAGES firmware-linux"
357      fi
358      # shellcheck disable=SC2086
359      DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
360   else
361      echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
362   fi
363 }
364 # }}}
365
366 # reconfigure packages {{{
367 reconfigure() {
368   if [ -n "$RECONFIGURE" ] ; then
369      for package in $RECONFIGURE ; do
370          if dpkg --list "$package" >/dev/null 2>&1 | grep -q '^ii' ; then
371            DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure "$package" || \
372            echo "Warning: $package does not exist, can not reconfigure it."
373          fi
374      done
375   fi
376 }
377 # }}}
378
379 # set password of user root {{{
380 passwords()
381 {
382   if [ -n "$NOPASSWORD" ] ; then
383     echo "Skip setting root password as requested."
384     return 0
385   fi
386
387   echo "Activating shadow passwords."
388   shadowconfig on
389
390   CHPASSWD_OPTION=
391   if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
392      CHPASSWD_OPTION='-m'
393   fi
394
395   if [ -n "$ROOTPASSWORD" ] ; then
396      # shellcheck disable=SC2086
397      echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
398      export ROOTPASSWORD=''
399   else
400     a='1'
401     b='2'
402      echo "Setting password for user root:"
403      while [ "$a" != "$b" ] ; do
404        printf "Enter new UNIX password for user root: "
405        askpass
406        a="$resp"
407        unset resp
408        echo
409        printf "Retype new UNIX password for user root: "
410        askpass
411        b="$resp"
412        unset resp
413        echo
414        if [ "$a" != "$b" ] ; then
415          echo "Sorry, passwords do not match. Retry."
416          a='1'
417          b='2'
418        else
419          # shellcheck disable=SC2086
420          echo root:"$a" | chpasswd $CHPASSWD_OPTION
421          unset a
422          unset b
423        fi
424      done
425   fi
426 }
427 # }}}
428
429 # set up /etc/hosts {{{
430 hosts() {
431   if ! [ -f /etc/hosts ] ; then
432      cat > /etc/hosts << EOF
433 127.0.0.1       localhost
434 ::1             localhost ip6-localhost ip6-loopback
435 ff02::1         ip6-allnodes
436 ff02::2         ip6-allrouters
437 EOF
438   fi
439 }
440 # }}}
441
442 # set default locales {{{
443 default_locales() {
444   if [ -n "$DEFAULT_LOCALES" ] ; then
445     if ! [ -x /usr/sbin/update-locale ] ; then
446       echo "Warning: update-locale executable not available (no locales package installed?)"
447       echo "Ignoring request to run update-locale for $DEFAULT_LOCALES therefore"
448       return 0
449     fi
450
451     /usr/sbin/update-locale LANGUAGE="$DEFAULT_LANGUAGE" LANG="$DEFAULT_LOCALES"
452   fi
453 }
454 # }}}
455
456 # adjust timezone {{{
457 timezone() {
458   if [ -n "$TIMEZONE" ] ; then
459     echo "Adjusting /etc/localtime"
460     ln -sf "/usr/share/zoneinfo/$TIMEZONE" /etc/localtime
461
462     echo "Setting /etc/timezone to $TIMEZONE"
463     printf '%s\n' "$TIMEZONE"  > /etc/timezone
464
465   fi
466 }
467 # }}}
468
469 # helper function for fstab() {{{
470 createfstab(){
471   echo "Setting up /etc/fstab"
472   cat > /etc/fstab <<EOF
473 # /etc/fstab - created by grml-debootstrap on $(date)
474 # Accessible filesystems, by reference, are maintained under '/dev/disk/'.
475 # See man pages fstab(5), findfs(8), mount(8) and/or blkid(8) for more info.
476 #
477 # After editing this file, run 'systemctl daemon-reload' to update systemd
478 # units generated from this file.
479 #
480 EOF
481
482   if [ -n "$TARGET_UUID" ] ; then
483     local rootfs_mount_options=""
484
485     if [ -z "${FILESYSTEM}" ] ; then
486       FILESYSTEM="$(blkid -o value -s TYPE /dev/disk/by-uuid/"${TARGET_UUID}")"
487     fi
488
489     case "${FILESYSTEM}" in
490       # errors=remount-ro is supported only by a few file systems
491       ext*|exfat|fat|jfs|nilfs2|vfat)
492         rootfs_mount_options=",errors=remount-ro"
493         ;;
494     esac
495
496     echo "/dev/disk/by-uuid/${TARGET_UUID} /  auto    defaults${rootfs_mount_options} 0   1" >> /etc/fstab
497   else
498     echo "Warning: couldn't identify target UUID for rootfs, your /etc/fstab might be incomplete."
499   fi
500
501 if [ -n "$EFI" ] ; then
502   # shellcheck disable=SC2086
503   echo "UUID=$(blkid -o value -s UUID $EFI)  /boot/efi       vfat    umask=0077      0       1" >> /etc/fstab
504 fi
505
506 cat >> /etc/fstab << EOF
507 proc           /proc        proc    defaults                      0   0
508 /dev/cdrom     /mnt/cdrom0  iso9660 ro,user,noauto                0   0
509 # some other examples:
510 # /dev/sda2       none         swap    sw,pri=0             0   0
511 # /dev/hda1       /Grml        ext3    dev,suid,user,noauto 0  2
512 # //1.2.3.4/pub   /smb/pub     cifs    user,noauto,uid=grml,gid=grml 0 0
513 # linux:/pub      /beer        nfs     defaults             0  0
514 # tmpfs           /tmp         tmpfs   size=300M            0  0
515 # /dev/sda5       none         swap    sw                   0  0
516 EOF
517 }
518 # }}}
519
520 # generate /etc/fstab {{{
521 fstab() {
522   # set up /etc/fstab if file is not present (cdebootstrap)
523   if [ ! -f /etc/fstab  ] ; then
524      createfstab
525   fi
526
527   # set up /etc/fstab if file is UNCONFIGURED (debootstrap)
528   if grep -q UNCONFIGURED /etc/fstab ; then
529      createfstab
530   fi
531 }
532 # }}}
533
534 # ensure we have according filesystem tools available {{{
535 install_fs_tools() {
536   local pkg=""
537
538   # note: this is supposed to be coming either via command lines'
539   # $_opt_filesystem or via createfstab()
540   case "${FILESYSTEM}" in
541     jfs)
542       pkg="jfsutils"
543       ;;
544     xfs)
545       pkg="xfsprogs"
546       ;;
547   esac
548
549   if [ -n "${pkg:-}" ] && ! dpkg --list "${pkg}" 2>/dev/null | grep -q '^ii' ; then
550     echo "Filesystem package ${pkg} not present, installing now"
551     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL "${pkg}"
552   fi
553 }
554 # }}}
555
556 # set up hostname {{{
557 hostname() {
558   if [ -n "$HOSTNAME" ] ; then
559      echo "Setting hostname to ${HOSTNAME}."
560      echo "$HOSTNAME" > /etc/hostname
561
562      # adjust postfix configuration
563      if [ -r /etc/postfix/main.cf ] ; then
564         # adjust hostname related options:
565         sed -i "s/grml/$HOSTNAME/g" /etc/postfix/main.cf
566
567         # listen on loopback interface only:
568         sed -i "s/^inet_interfaces = .*/inet_interfaces = loopback-only/" /etc/postfix/main.cf
569         grep -q inet_interfaces /etc/postfix/main.cf || echo 'inet_interfaces = loopback-only' >> /etc/postfix/main.cf
570      fi
571      if [ -r /etc/mailname ] ; then
572         # adjust /etc/mailname
573         local etc_mail_domain
574         etc_mail_domain=$(/bin/dnsdomainname 2>/dev/null || echo localdomain)
575         case "$HOSTNAME" in
576           *.*)
577             local mailname="$HOSTNAME"
578             ;;
579           *)
580             local mailname="${HOSTNAME}.${etc_mail_domain}"
581             ;;
582         esac
583         echo "Setting mailname to ${mailname}"
584         echo "$mailname" > /etc/mailname
585      fi
586   fi
587 }
588 # }}}
589
590 # generate initrd/initramfs {{{
591 initrd() {
592   # assume the first available kernel as our main kernel
593   # shellcheck disable=SC2012
594   KERNELIMG=$(ls -1 /boot/vmlinuz-* 2>/dev/null | head -1)
595   if [ -z "$KERNELIMG" ] ; then
596      echo 'No kernel image found, skipping initrd stuff.'>&2
597      return
598   fi
599
600   KERNELVER=${KERNELIMG#/boot/vmlinuz-}
601
602   # generate initrd
603   if [ -n "$INITRD" ] ; then
604      echo "Generating initrd."
605      if [ "$INITRD_GENERATOR" = 'dracut' ] ; then
606          DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL dracut
607          # shellcheck disable=SC2086
608          dracut --no-hostonly --kver "$KERNELVER" --fstab --add-fstab /etc/fstab --force --reproducible $INITRD_GENERATOR_OPTS
609      else
610          # shellcheck disable=SC2086
611          update-initramfs -c -t -k "$KERNELVER" $INITRD_GENERATOR_OPTS
612      fi
613   fi
614 }
615 # }}}
616
617 efi_setup() {
618   if [ -z "$EFI" ] ; then
619     return 0
620   fi
621
622   if ! dpkg --list efibootmgr 2>/dev/null | grep -q '^ii' ; then
623     echo "Notice: efi option set but no efibootmgr package, installing it therefore."
624     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL efibootmgr
625   fi
626
627   mkdir -p /boot/efi
628   echo "Mounting $EFI on /boot/efi"
629   mount "$EFI" /boot/efi || return 1
630
631   # if efivarfs kernel module is loaded, but efivars isn't,
632   # then we need to mount efivarfs for efibootmgr usage
633   if ! ls /sys/firmware/efi/efivars/* &>/dev/null ; then
634     echo "Mounting efivarfs on /sys/firmware/efi/efivars"
635     mount -t efivarfs efivarfs /sys/firmware/efi/efivars
636   fi
637
638   echo "Invoking efibootmgr"
639   efibootmgr || return 1
640 }
641
642 # grub configuration/installation {{{
643
644 # helper function to get relevant /dev/disk/by-id/* entries,
645 # based on GRUB's postinst script
646 available_ids() {
647   local path ids
648
649   [ -d /dev/disk/by-id ] || return
650   ids="$(
651     for path in /dev/disk/by-id/*; do
652       [ -e "${path}" ] || continue
653       printf '%s %s\n' "${path}" "$(readlink -f "${path}")"
654     done | sort -k2 -s -u | cut -d' ' -f1
655   )"
656   echo "${ids}"
657 }
658
659 # helper function to report corresponding /dev/disk/by-id/ for a given device name,
660 # based on GRUB's postinst script
661 device_to_id() {
662   local id
663
664   for id in $(available_ids); do
665     if [ "$(readlink -f "${id}")" = "$(readlink -f "$1")" ]; then
666       echo "${id}"
667       return 0
668     fi
669   done
670
671   # Fall back to the plain device name if there's no by-id link for it.
672   if [ -e "$1" ]; then
673     echo "$1"
674     return 0
675   fi
676   return 1
677 }
678
679 grub_install() {
680
681   if [ -z "$GRUB" ] ; then
682     echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
683     return 0
684   fi
685
686   efi_setup || return 1
687
688   if [ -n "$EFI" ] ; then
689     GRUB_PACKAGE=grub-efi-amd64
690   else
691     GRUB_PACKAGE=grub-pc
692   fi
693
694   # make sure this is pre-defined so we have sane settings for automated
695   # upgrades, see https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=711019
696   local grub_device
697   grub_device=$(device_to_id "${GRUB}")
698   if [ -z "${grub_device:-}" ] ; then
699      echo "Warning: Could not identify /dev/disk/by-id/... for '${GRUB}', falling back to '${GRUB}'"
700      grub_device="${GRUB}"
701   fi
702
703   echo "Setting ${GRUB_PACKAGE} debconf configuration for install device to $GRUB"
704   echo "${GRUB_PACKAGE} ${GRUB_PACKAGE}/install_devices multiselect ${grub_device}" | debconf-set-selections
705
706   if ! dpkg --list "${GRUB_PACKAGE}" 2>/dev/null | grep -q '^ii' ; then
707     echo "Notice: grub option set but no ${GRUB_PACKAGE} package, installing it therefore."
708     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL "${GRUB_PACKAGE}"
709   fi
710
711   if ! [ -x "$(command -v grub-install)" ] ; then
712      echo "Error: grub-install not available. (Error while installing grub package?)" >&2
713      return 1
714   fi
715   if ! [ -x "$(command -v update-grub)" ] ; then
716      echo "Error: update-grub not available. (Error while installing grub package?)" >&2
717      return 1
718   fi
719
720   if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
721      for device in $SELECTED_PARTITIONS ; do
722         GRUB="${device%%[0-9]}"
723         echo "Installing grub on ${GRUB}:"
724         if ! grub-install --no-floppy "$GRUB" ; then
725           echo "Error: failed to execute 'grub-install --no-floppy $GRUB'." >&2
726           exit 1
727         fi
728
729      done
730      rm -f /boot/grub/device.map
731   else
732     echo "Installing grub on ${GRUB}:"
733     echo "(hd0) ${GRUB}" > /boot/grub/device.map
734     if ! grub-install "(hd0)" ; then
735       echo "Error: failed to execute 'grub-install (hd0)'." >&2
736       exit 1
737     fi
738     rm /boot/grub/device.map
739   fi
740
741   echo "Adjusting grub configuration for use on ${GRUB}."
742
743   if [ -n "${BOOT_APPEND}" ] ; then
744     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
745     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" /etc/default/grub
746   fi
747
748   mountpoint /boot/efi &>/dev/null && umount /boot/efi
749
750   # finally install grub. Existence of update-grub is checked above.
751   update-grub
752 }
753 # }}}
754
755 # execute all scripts present in /etc/debootstrap/chroot-scripts/ {{{
756 custom_scripts() {
757   [ -d /etc/debootstrap/chroot-scripts/ ] || return 0
758
759   for script in /etc/debootstrap/chroot-scripts/* ; do
760       echo "Executing script $script"
761       $script && echo "done" || echo "failed"
762   done
763 }
764 # }}}
765
766 # make sure we don't have any running processes left {{{
767 services() {
768   for service in ssh mdadm mdadm-raid ; do
769     if [ -x /etc/init.d/"$service" ] ; then
770        /etc/init.d/"$service" stop || true
771     fi
772   done
773 }
774 # }}}
775
776 # unmount /proc and make sure nothing is left {{{
777 finalize() {
778   # make sure we don't leave any sensible data
779   rm -f /etc/debootstrap/variables
780
781   [ -n "$POLICYRCD" ] && rm -f /usr/sbin/policy-rc.d
782
783   umount /sys/firmware/efi/efivars &>/dev/null || true
784
785   umount /sys >/dev/null 2>/dev/null || true
786   umount /proc >/dev/null 2>/dev/null || true
787 }
788 # }}}
789
790 # signal handler {{{
791 signal_handler() {
792   finalize
793   [ -n "$1" ] && EXIT="$1" || EXIT="1"
794   exit "$EXIT"
795 }
796 # }}}
797
798 # set signal handler {{{
799 trap signal_handler HUP INT QUIT TERM
800 # }}}
801
802 # execute the functions {{{
803
804  # always execute install_policy_rcd
805  install_policy_rcd
806
807  for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
808      kernel packages extrapackages reconfigure hosts \
809      default_locales timezone fstab install_fs_tools hostname \
810      initrd grub_install passwords \
811      custom_scripts upgrade_system remove_apt_cache services \
812      remove_chrootmirror; do
813      if stage $i ; then
814        $i && stage $i 'done' || exit 1
815      fi
816   done
817   # always execute the finalize stage:
818   finalize
819 # }}}
820
821 # finally exit the chroot {{{
822   echo "Finished chroot installation, exiting."
823   exit 0
824 # }}}
825
826 ## END OF FILE #################################################################
827 # vim: ai tw=80 expandtab foldmethod=marker